## 1.构建镜像

### 1.1 构建策略

构建oai ran docker镜像的过程分为三步，先创建``ran-base``镜像（包含所有依赖包），再创建``ran-build``镜像（用于编译目标程序），最后得到``oai-gnb``、``oai-nr-ue``、``oai-cu-up``等目标镜像

或者也可以直接从docker hub上下载官方镜像文件

```shell
docker pull oaisoftwarealliance/oai-gnb:develop
docker pull oaisoftwarealliance/oai-nr-ue:develop
```

### 1.2 文件组织

Dockerfiles的命名规则为：``Dockerfile.${target}.${OS-version}``

### 1.3 构建

首先是构建两个基础镜像ran-base和ran-build

```shell
git clone https://gitee.com/openxg/openxg-ran.git
cd openxg-ran

sudo docker build --target ran-base --tag ran-base:latest --file docker/Dockerfile.base.ubuntu20 .

sudo docker build --target ran-build --tag ran-build:latest --file docker/Dockerfile.build.ubuntu20 .
```

接下来构建目标镜像

```shell
#构建gnb
sudo docker build --target oai-gnb --tag oai-gnb:latest --file docker/Dockerfile.gNB.ubuntu20 .
#构建nr-ue
sudo docker build --target oai-nr-ue --tag oai-nr-ue:latest --file docker/Dockerfile.nrUE.ubuntu20 .
```

## 2. 启动镜像

### 2.1 拓扑图

![tuopu](https://cdn.jsdelivr.net/gh/lidabing1999/image/img/tuopu.png)

在容器跨主机通信的时候需要添加路由

```
sudo route add -net 192.168.70.128 mask 255.255.255.192 gw <远程主机ip>
```



### 2.2 运行

本样例是启动rfsim模式

核心网的启动参考oai5g-cn项目

基站和终端

```shell
git clone http://gitlab.openxg.org.cn/openxg/oai-ran-docker.git
#启动基站
cd oai-ran-docker/5g_simulator/gnb
sudo docker-compose up -d oai-gnb
#启动终端
cd oai-ran-docker/5g_simulator/ue
sudo docker-compose up -d oai-nr-ue
#关闭容器
sudo docker-compose down -t 0
```

### 2.3 验证

```shell
sudo docker exec -it rfsim5g-oai-nr-ue /bin/bash
ping www.baidu.com -I oaitun_ue1
```

如果用网卡且可以ping通百度，则说明系统搭建完成
